package dslab.test;

import static org.junit.Assert.fail;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 * NOTE: DO *NOT* CHANGE THIS FILE!
 */
public class SampleTest {

	private static Server server;
	private final static int tcpPort = 1337;
	private final static int registryPort = 1338;
	private final static String bindingName = "Server";
	private static Client client;

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		server = new Server(tcpPort, registryPort, bindingName);
		server.init();
		new Thread(server).start();
		Thread.sleep(1000);
		client = new Client();
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		server.close();
	}

	@Test
	public void testClient_hello() throws Exception {
		client.hello();
		checkIfSucceeded("hello");
	}

	@Test
	public void testClient_bye() throws Exception {
		client.bye();
		checkIfSucceeded("bye");
	}

	private void checkIfSucceeded(String id) throws Exception {
		Thread.sleep(1000);
		Result result = server.getResult(id);
		if (!result.isSucceeded())
			fail(result.getMessage());
	}

}
